### Virtual Method

# GtkSource CompletionProvider list_alternates

#### Declaration [src]

    GPtrArray*
    list_alternates (
      GtkSourceCompletionProvider* self,
      GtkSourceCompletionContext* context,
      GtkSourceCompletionProposal* proposal
    )

#### Description [src]

Providers should return a list of alternates to `proposal` or `NULL` if there are no alternates available.

This can be used by the completion view to allow the user to move laterally through similar proposals, such as overrides of methods by the same name.

#### Parameters

`context`

  Type: `GtkSourceCompletionContext`

  A `GtkSourceCompletionContext`.

  The data is owned by the caller of the method.

`proposal`

  Type: `GtkSourceCompletionProposal`

  A `GtkSourceCompletionProposal`.

  The data is owned by the caller of the method.

#### Return value

Type: An array of `GtkSourceCompletionProposal*`

a `GPtrArray` of `GtkSourceCompletionProposal` or `NULL`.

The caller of the method takes ownership of the returned data, and is responsible for freeing it.
The return value can be `NULL`.